diff --git a/src/backend/utils/adt/ddlutils.c b/src/backend/utils/adt/ddlutils.c
index a70f1c28655..d72a74df6a5 100644
--- a/src/backend/utils/adt/ddlutils.c
+++ b/src/backend/utils/adt/ddlutils.c
@@ -5,7 +5,7 @@
  *
  * This file contains the pg_get_*_ddl family of functions that generate
  * DDL statements to recreate database objects such as roles, tablespaces,
- * and databases, along with common infrastructure for option parsing and
+ * databases, and tables, along with common infrastructure for
  * pretty-printing.
  *
  * Portions Copyright (c) 1996-2026, PostgreSQL Global Development Group
@@ -21,30 +21,92 @@
 #include "access/genam.h"
 #include "access/htup_details.h"
 #include "access/table.h"
+#include "access/toast_compression.h"
+#include "catalog/namespace.h"
+#include "catalog/partition.h"
+#include "catalog/pg_am.h"
 #include "catalog/pg_auth_members.h"
 #include "catalog/pg_authid.h"
+#include "catalog/pg_class.h"
 #include "catalog/pg_collation.h"
+#include "catalog/pg_constraint.h"
 #include "catalog/pg_database.h"
 #include "catalog/pg_db_role_setting.h"
+#include "catalog/pg_index.h"
+#include "catalog/pg_inherits.h"
+#include "catalog/pg_policy.h"
+#include "catalog/pg_rewrite.h"
+#include "catalog/pg_sequence.h"
+#include "catalog/pg_statistic_ext.h"
 #include "catalog/pg_tablespace.h"
+#include "catalog/pg_trigger.h"
+#include "rewrite/rewriteDefine.h"
+#include "commands/defrem.h"
+#include "commands/tablecmds.h"
 #include "commands/tablespace.h"
-#include "common/relpath.h"
 #include "funcapi.h"
 #include "mb/pg_wchar.h"
 #include "miscadmin.h"
 #include "utils/acl.h"
+#include "utils/array.h"
 #include "utils/builtins.h"
 #include "utils/datetime.h"
 #include "utils/fmgroids.h"
 #include "utils/guc.h"
 #include "utils/lsyscache.h"
-#include "utils/pg_locale.h"
 #include "utils/rel.h"
 #include "utils/ruleutils.h"
 #include "utils/syscache.h"
 #include "utils/timestamp.h"
 #include "utils/varlena.h"
 
+/*
+ * Object-class kinds that the only / except options on
+ * pg_get_table_ddl can filter on.  Members are stored as integers in a
+ * Bitmapset on TableDdlContext.  Keep table_ddl_kind_names[] in sync
+ * with the order of additions here.
+ */
+typedef enum TableDdlKind
+{
+	TABLE_DDL_KIND_TABLE,
+	TABLE_DDL_KIND_INDEX,
+	TABLE_DDL_KIND_PRIMARY_KEY,
+	TABLE_DDL_KIND_UNIQUE,
+	TABLE_DDL_KIND_CHECK,
+	TABLE_DDL_KIND_FOREIGN_KEY,
+	TABLE_DDL_KIND_EXCLUSION,
+	TABLE_DDL_KIND_RULE,
+	TABLE_DDL_KIND_STATISTICS,
+	TABLE_DDL_KIND_TRIGGER,
+	TABLE_DDL_KIND_POLICY,
+	TABLE_DDL_KIND_RLS,
+	TABLE_DDL_KIND_REPLICA_IDENTITY,
+	TABLE_DDL_KIND_PARTITION,
+}			TableDdlKind;
+
+static const struct
+{
+	const char *name;
+	TableDdlKind kind;
+}			table_ddl_kind_names[] =
+{
+	{"table", TABLE_DDL_KIND_TABLE},
+	{"index", TABLE_DDL_KIND_INDEX},
+	{"primary_key", TABLE_DDL_KIND_PRIMARY_KEY},
+	{"unique", TABLE_DDL_KIND_UNIQUE},
+	{"check", TABLE_DDL_KIND_CHECK},
+	{"foreign_key", TABLE_DDL_KIND_FOREIGN_KEY},
+	{"exclusion", TABLE_DDL_KIND_EXCLUSION},
+	{"rule", TABLE_DDL_KIND_RULE},
+	{"statistics", TABLE_DDL_KIND_STATISTICS},
+	{"trigger", TABLE_DDL_KIND_TRIGGER},
+	{"policy", TABLE_DDL_KIND_POLICY},
+	{"rls", TABLE_DDL_KIND_RLS},
+	{"replica_identity", TABLE_DDL_KIND_REPLICA_IDENTITY},
+	{"partition", TABLE_DDL_KIND_PARTITION},
+};
+
+static Bitmapset *parse_kind_array(const char *paramname, ArrayType *arr);
 static void append_ddl_option(StringInfo buf, bool pretty, int indent,
 							  const char *fmt, ...)
 			pg_attribute_printf(4, 5);
@@ -57,6 +119,215 @@ static Datum pg_get_tablespace_ddl_srf(FunctionCallInfo fcinfo, Oid tsid);
 static List *pg_get_database_ddl_internal(Oid dbid, bool pretty,
 										  bool no_owner, bool no_tablespace);
 
+/*
+ * Per-column cache of locally-declared NOT NULL constraints.  Built once
+ * by collect_local_not_null() and consulted by the column-emit helpers
+ * and the post-CREATE constraint loop.  Entries with conoid == InvalidOid
+ * mean the column has no local NOT NULL constraint row in pg_constraint
+ * (the column may still have attnotnull=true on a pre-PG-18-upgraded
+ * catalog, in which case emit plain inline NOT NULL).
+ *
+ * inherited_notnull is set when a NOT NULL constraint row exists in
+ * pg_constraint but conislocal=false (purely inherited).  In that case
+ * the NOT NULL must not be emitted in the column list: the INHERITS /
+ * PARTITION OF clause already propagates it, and emitting it here would
+ * flip conislocal to true on replay.
+ */
+typedef struct LocalNotNullEntry
+{
+	Oid			conoid;
+	char	   *name;
+	bool		is_auto;		/* matches "<table>_<col>_not_null" */
+	bool		no_inherit;
+	bool		inherited_notnull;	/* row exists but conislocal=false */
+	bool		not_valid;		/* constraint has convalidated=false */
+}			LocalNotNullEntry;
+
+/*
+ * Working context threaded through the per-pass helpers below.  Inputs
+ * (caller-provided option flags) are filled in once at the top of
+ * pg_get_table_ddl_internal and treated as read-only thereafter.  Derived
+ * fields (qualname, nn_entries, skip_notnull_oids) are computed once
+ * during setup.  Each pass appends to ctx->buf and pushes the finished
+ * statement onto ctx->statements via append_stmt().
+ */
+typedef struct TableDdlContext
+{
+	Relation	rel;
+	Oid			relid;
+	bool		pretty;
+	bool		no_owner;
+	bool		no_tablespace;
+	bool		schema_qualified;
+
+	/*
+	 * Object-class filtering.  If only_kinds is non-NULL, only the
+	 * kinds in that set are emitted; if except_kinds is non-NULL, all
+	 * kinds *except* those in that set are emitted; if both are NULL,
+	 * every kind is emitted (the default).  The two are mutually
+	 * exclusive at the user-facing layer (the SRF entry rejects
+	 * specifying both).
+	 */
+	Bitmapset  *only_kinds;
+	Bitmapset  *except_kinds;
+
+	/* Derived during setup */
+	Oid			base_namespace;
+	char	   *qualname;
+	int			save_nestlevel; /* >= 0 if we narrowed search_path */
+	LocalNotNullEntry *nn_entries;
+	List	   *skip_notnull_oids;
+
+	/* Mutable working state */
+	StringInfoData buf;
+	List	   *statements;
+}			TableDdlContext;
+
+static List *pg_get_table_ddl_internal(TableDdlContext *ctx);
+static bool is_kind_included(const TableDdlContext *ctx, TableDdlKind kind);
+static void append_column_defs(StringInfo buf, Relation rel, bool pretty,
+							   bool include_check,
+							   bool schema_qualified,
+							   LocalNotNullEntry *nn_entries);
+static void append_typed_column_overrides(StringInfo buf, Relation rel,
+										  bool pretty, bool include_check,
+										  LocalNotNullEntry *nn_entries);
+static void append_inline_check_constraints(StringInfo buf, Relation rel,
+											bool pretty, bool *first);
+static char *find_attrdef_text(Relation rel, AttrNumber attnum,
+							   List **dpcontext);
+static bool child_default_inherited_from_parent(Oid childOid,
+												 const char *attname,
+												 const char *child_adbin);
+static char *format_name_for_emit(const char *name, Oid nsp,
+								  bool schema_qualified, Oid base_namespace);
+static char *lookup_relname_for_emit(Oid relid, bool schema_qualified,
+									 Oid base_namespace);
+static LocalNotNullEntry *collect_local_not_null(Relation rel,
+												  List **skip_oids);
+static bool parent_has_default_for_col(Oid childOid, const char *attname);
+
+static void append_stmt(TableDdlContext *ctx);
+static void emit_create_table_stmt(TableDdlContext *ctx);
+static void emit_owner_stmt(TableDdlContext *ctx);
+static void emit_child_default_overrides(TableDdlContext *ctx);
+static void emit_attoptions(TableDdlContext *ctx);
+static void emit_typed_column_storage(TableDdlContext *ctx);
+static void emit_identity_sequence_alterations(TableDdlContext *ctx);
+static void emit_index_column_statistics(TableDdlContext *ctx, Oid idxoid,
+										 int indnkeyatts);
+static void emit_indexes(TableDdlContext *ctx);
+static void emit_cluster_on(TableDdlContext *ctx);
+static void emit_local_constraints(TableDdlContext *ctx);
+static void emit_rules(TableDdlContext *ctx);
+static void emit_statistics(TableDdlContext *ctx);
+static void emit_replica_identity(TableDdlContext *ctx);
+static void emit_rls_toggles(TableDdlContext *ctx);
+static void emit_partition_children(TableDdlContext *ctx);
+
+
+/*
+ * parse_kind_array
+ *		Parse a text[] of object-class kind names into a Bitmapset of
+ *		TableDdlKind values.
+ *
+ * Each element is matched case-insensitively; surrounding whitespace is
+ * stripped.  NULL elements are rejected.  Unknown kind names raise an error
+ * citing the supplied parameter name.  An empty array is also rejected.
+ * Duplicate entries are silently de-duplicated by the Bitmapset.
+ */
+static Bitmapset *
+parse_kind_array(const char *paramname, ArrayType *arr)
+{
+	Datum	   *elems;
+	bool	   *nulls;
+	int			nelems;
+	Bitmapset  *result = NULL;
+
+	deconstruct_array_builtin(arr, TEXTOID, &elems, &nulls, &nelems);
+
+	if (nelems == 0)
+		ereport(ERROR,
+				(errcode(ERRCODE_INVALID_PARAMETER_VALUE),
+				 errmsg("parameter \"%s\" must specify at least one kind",
+						paramname)));
+
+	for (int i = 0; i < nelems; i++)
+	{
+		char	   *raw;
+		char	   *token;
+		char	   *end;
+		bool		found = false;
+
+		if (nulls[i])
+			ereport(ERROR,
+					(errcode(ERRCODE_INVALID_PARAMETER_VALUE),
+					 errmsg("parameter \"%s\" must not contain NULL elements",
+							paramname)));
+
+		raw = text_to_cstring(DatumGetTextPP(elems[i]));
+
+		/* Trim leading whitespace. */
+		token = raw;
+		while (*token == ' ' || *token == '\t')
+			token++;
+
+		/* Trim trailing whitespace. */
+		end = token + strlen(token);
+		while (end > token && (end[-1] == ' ' || end[-1] == '\t'))
+			end--;
+		*end = '\0';
+
+		for (size_t j = 0; j < lengthof(table_ddl_kind_names); j++)
+		{
+			if (pg_strcasecmp(token, table_ddl_kind_names[j].name) == 0)
+			{
+				result = bms_add_member(result,
+										(int) table_ddl_kind_names[j].kind);
+				found = true;
+				break;
+			}
+		}
+
+		if (!found)
+		{
+			/*
+			 * token points into raw, so copy it before freeing raw to avoid
+			 * a use-after-free in the error message.
+			 */
+			char	   *bad_kind = pstrdup(token);
+
+			pfree(raw);
+			pfree(elems);
+			pfree(nulls);
+			ereport(ERROR,
+					(errcode(ERRCODE_INVALID_PARAMETER_VALUE),
+					 errmsg("unrecognized kind \"%s\" in parameter \"%s\"",
+							bad_kind, paramname)));
+		}
+
+		pfree(raw);
+	}
+
+	pfree(elems);
+	pfree(nulls);
+	return result;
+}
+
+/*
+ * is_kind_included
+ *		Determine whether DDL for the given object-class kind should be
+ *		emitted under the current options.
+ */
+static bool
+is_kind_included(const TableDdlContext *ctx, TableDdlKind kind)
+{
+	if (ctx->only_kinds != NULL)
+		return bms_is_member((int) kind, ctx->only_kinds);
+	if (ctx->except_kinds != NULL)
+		return !bms_is_member((int) kind, ctx->except_kinds);
+	return true;
+}
 
 /*
  * Helper to append a formatted string with optional pretty-printing.
